package com.imcode.db.mock;

import org.apache.commons.lang.NotImplementedException;
import org.apache.commons.dbutils.ResultSetHandler;

import java.sql.*;
import java.util.Map;
import java.util.Calendar;
import java.util.SortedMap;
import java.util.TreeMap;
import java.io.InputStream;
import java.io.Reader;
import java.math.BigDecimal;
import java.net.URL;

import com.imcode.db.commands.SqlQueryCommand;

public class MockConnection implements Connection {

    private final MockDatabase database;

    public MockConnection(MockDatabase database) {
        this.database = database;
    }

    public int getTransactionIsolation() {
        throw new NotImplementedException( MockConnection.class );
    }

    public void setTypeMap(Map map) {
        throw new NotImplementedException( MockConnection.class );
    }

    public int getHoldability() throws SQLException {
        throw new NotImplementedException( MockConnection.class );
    }

    public void clearWarnings() throws SQLException {
        throw new NotImplementedException( MockConnection.class );
    }

    public void close() throws SQLException {
    }

    public void commit() throws SQLException {}

    public void rollback() throws SQLException {}

    public boolean getAutoCommit() throws SQLException {
        throw new NotImplementedException( MockConnection.class );
    }

    public boolean isClosed() throws SQLException {
        throw new NotImplementedException( MockConnection.class );
    }

    public boolean isReadOnly() throws SQLException {
        throw new NotImplementedException( MockConnection.class );
    }

    public void setHoldability( int holdability ) throws SQLException {
        throw new NotImplementedException( MockConnection.class );
    }

    public void setTransactionIsolation( int level ) throws SQLException {
    }

    public void setAutoCommit( boolean autoCommit ) throws SQLException {
    }

    public void setReadOnly( boolean readOnly ) throws SQLException {
        throw new NotImplementedException( MockConnection.class );
    }

    public String getCatalog() throws SQLException {
        throw new NotImplementedException( MockConnection.class );
    }

    public void setCatalog( String catalog ) throws SQLException {
        throw new NotImplementedException( MockConnection.class );
    }

    public DatabaseMetaData getMetaData() throws SQLException {
        throw new NotImplementedException( MockConnection.class );
    }

    public SQLWarning getWarnings() throws SQLException {
        throw new NotImplementedException( MockConnection.class );
    }

    public Savepoint setSavepoint() throws SQLException {
        throw new NotImplementedException( MockConnection.class );
    }

    public void releaseSavepoint( Savepoint savepoint ) throws SQLException {
        throw new NotImplementedException( MockConnection.class );
    }

    public void rollback( Savepoint savepoint ) throws SQLException {
        throw new NotImplementedException( MockConnection.class );
    }

    public Statement createStatement() throws SQLException {
        throw new NotImplementedException( MockConnection.class );
    }

    public Statement createStatement( int resultSetType, int resultSetConcurrency )
            throws SQLException {
        throw new NotImplementedException( MockConnection.class );
    }

    public Statement createStatement( int resultSetType, int resultSetConcurrency,
                                      int resultSetHoldability ) throws SQLException {
        throw new NotImplementedException( MockConnection.class );
    }

    public Map getTypeMap() throws SQLException {
        throw new NotImplementedException( MockConnection.class );
    }

    public String nativeSQL( String sql ) throws SQLException {
        throw new NotImplementedException( MockConnection.class );
    }

    public CallableStatement prepareCall( String sql ) throws SQLException {
        throw new NotImplementedException( MockConnection.class );
    }

    public CallableStatement prepareCall( String sql, int resultSetType,
                                          int resultSetConcurrency ) throws SQLException {
        throw new NotImplementedException( MockConnection.class );
    }

    public CallableStatement prepareCall( String sql, int resultSetType,
                                          int resultSetConcurrency,
                                          int resultSetHoldability ) throws SQLException {
        throw new NotImplementedException( MockConnection.class );
    }

    public PreparedStatement prepareStatement( String sql )
            throws SQLException {
        return new MockPreparedStatement(database, sql);
    }

    public PreparedStatement prepareStatement( String sql, int autoGeneratedKeys )
            throws SQLException {
        throw new NotImplementedException( MockConnection.class );
    }

    public PreparedStatement prepareStatement( String sql, int resultSetType,
                                               int resultSetConcurrency )
            throws SQLException {
        throw new NotImplementedException( MockConnection.class );
    }

    public PreparedStatement prepareStatement( String sql, int resultSetType,
                                               int resultSetConcurrency, int resultSetHoldability )
            throws SQLException {
        throw new NotImplementedException( MockConnection.class );
    }

    public PreparedStatement prepareStatement( String sql, int columnIndexes[] )
            throws SQLException {
        throw new NotImplementedException( MockConnection.class );
    }

    public Savepoint setSavepoint( String name ) throws SQLException {
        throw new NotImplementedException( MockConnection.class );
    }

    public PreparedStatement prepareStatement( String sql, String columnNames[] )
            throws SQLException {
        throw new NotImplementedException( MockConnection.class );
    }

    private static class MockPreparedStatement implements PreparedStatement {

        private final MockDatabase database;
        private SortedMap parameters = new TreeMap();
        private final String sql;

        public MockPreparedStatement(MockDatabase database, String sql) {
            this.database = database;
            this.sql = sql;
        }

        public int executeUpdate() throws SQLException {
            throw new NotImplementedException(".executeUpdate");
        }

        public void addBatch() throws SQLException {
            throw new NotImplementedException(".addBatch");
        }

        public void clearParameters() throws SQLException {
            throw new NotImplementedException(".clearParameters");
        }

        public boolean execute() throws SQLException {
            throw new NotImplementedException(".execute");
        }

        public void setByte(int parameterIndex, byte x) throws SQLException {
            throw new NotImplementedException(".setByte");
        }

        public void setDouble(int parameterIndex, double x) throws SQLException {
            throw new NotImplementedException(".setDouble");
        }

        public void setFloat(int parameterIndex, float x) throws SQLException {
            throw new NotImplementedException(".setFloat");
        }

        public void setInt(int parameterIndex, int x) throws SQLException {
            setObject(parameterIndex, new Integer(x)) ;
        }

        public void setNull(int parameterIndex, int sqlType) throws SQLException {
            throw new NotImplementedException(".setNull");
        }

        public void setLong(int parameterIndex, long x) throws SQLException {
            throw new NotImplementedException(".setLong");
        }

        public void setShort(int parameterIndex, short x) throws SQLException {
            throw new NotImplementedException(".setShort");
        }

        public void setBoolean(int parameterIndex, boolean x) throws SQLException {
            throw new NotImplementedException(".setBoolean");
        }

        public void setBytes(int parameterIndex, byte x[]) throws SQLException {
            throw new NotImplementedException(".setBytes");
        }

        public void setAsciiStream(int parameterIndex, InputStream x, int length) throws SQLException {
            throw new NotImplementedException(".setAsciiStream");
        }

        public void setBinaryStream(int parameterIndex, InputStream x, int length) throws SQLException {
            throw new NotImplementedException(".setBinaryStream");
        }

        public void setUnicodeStream(int parameterIndex, InputStream x, int length) throws SQLException {
            throw new NotImplementedException(".setUnicodeStream");
        }

        public void setCharacterStream(int parameterIndex, Reader reader, int length) throws SQLException {
            throw new NotImplementedException(".setCharacterStream");
        }

        public void setObject(int parameterIndex, Object x) throws SQLException {
            parameters.put(new Integer(parameterIndex), x) ;
        }

        public void setObject(int parameterIndex, Object x, int targetSqlType) throws SQLException {
            throw new NotImplementedException(".setObject");
        }

        public void setObject(int parameterIndex, Object x, int targetSqlType, int scale) throws SQLException {
            throw new NotImplementedException(".setObject");
        }

        public void setNull(int paramIndex, int sqlType, String typeName) throws SQLException {
            throw new NotImplementedException(".setNull");
        }

        public void setString(int parameterIndex, String x) throws SQLException {
            throw new NotImplementedException(".setString");
        }

        public void setBigDecimal(int parameterIndex, BigDecimal x) throws SQLException {
            throw new NotImplementedException(".setBigDecimal");
        }

        public void setURL(int parameterIndex, URL x) throws SQLException {
            throw new NotImplementedException(".setURL");
        }

        public void setArray(int i, Array x) throws SQLException {
            throw new NotImplementedException(".setArray");
        }

        public void setBlob(int i, Blob x) throws SQLException {
            throw new NotImplementedException(".setBlob");
        }

        public void setClob(int i, Clob x) throws SQLException {
            throw new NotImplementedException(".setClob");
        }

        public void setDate(int parameterIndex, Date x) throws SQLException {
            throw new NotImplementedException(".setDate");
        }

        public ParameterMetaData getParameterMetaData() throws SQLException {
            throw new NotImplementedException(".getParameterMetaData");
        }

        public void setRef(int i, Ref x) throws SQLException {
            throw new NotImplementedException(".setRef");
        }

        public ResultSet executeQuery() throws SQLException {
            Object[] parameterArray = parameters.values().toArray();
            return (ResultSet) database.execute(new SqlQueryCommand(sql, parameterArray, new ResultSetHandler() {
                public Object handle(ResultSet resultSet) {
                    return resultSet;
                }
            })) ;
        }

        public ResultSetMetaData getMetaData() throws SQLException {
            throw new NotImplementedException(".getMetaData");
        }

        public void setTime(int parameterIndex, Time x) throws SQLException {
            throw new NotImplementedException(".setTime");
        }

        public void setTimestamp(int parameterIndex, Timestamp x) throws SQLException {
            throw new NotImplementedException(".setTimestamp");
        }

        public void setDate(int parameterIndex, Date x, Calendar cal) throws SQLException {
            throw new NotImplementedException(".setDate");
        }

        public void setTime(int parameterIndex, Time x, Calendar cal) throws SQLException {
            throw new NotImplementedException(".setTime");
        }

        public void setTimestamp(int parameterIndex, Timestamp x, Calendar cal) throws SQLException {
            throw new NotImplementedException(".setTimestamp");
        }

        public int getFetchDirection() throws SQLException {
            throw new NotImplementedException(".getFetchDirection");
        }

        public int getFetchSize() throws SQLException {
            throw new NotImplementedException(".getFetchSize");
        }

        public int getMaxFieldSize() throws SQLException {
            throw new NotImplementedException(".getMaxFieldSize");
        }

        public int getMaxRows() throws SQLException {
            throw new NotImplementedException(".getMaxRows");
        }

        public int getQueryTimeout() throws SQLException {
            throw new NotImplementedException(".getQueryTimeout");
        }

        public int getResultSetConcurrency() throws SQLException {
            throw new NotImplementedException(".getResultSetConcurrency");
        }

        public int getResultSetHoldability() throws SQLException {
            throw new NotImplementedException(".getResultSetHoldability");
        }

        public int getResultSetType() throws SQLException {
            throw new NotImplementedException(".getResultSetType");
        }

        public int getUpdateCount() throws SQLException {
            throw new NotImplementedException(".getUpdateCount");
        }

        public void cancel() throws SQLException {
            throw new NotImplementedException(".cancel");
        }

        public void clearBatch() throws SQLException {
            throw new NotImplementedException(".clearBatch");
        }

        public void clearWarnings() throws SQLException {
            throw new NotImplementedException(".clearWarnings");
        }

        public void close() throws SQLException {
        }

        public boolean getMoreResults() throws SQLException {
            throw new NotImplementedException(".getMoreResults");
        }

        public int[] executeBatch() throws SQLException {
            throw new NotImplementedException(".executeBatch");
        }

        public void setFetchDirection(int direction) throws SQLException {
            throw new NotImplementedException(".setFetchDirection");
        }

        public void setFetchSize(int rows) throws SQLException {
            throw new NotImplementedException(".setFetchSize");
        }

        public void setMaxFieldSize(int max) throws SQLException {
            throw new NotImplementedException(".setMaxFieldSize");
        }

        public void setMaxRows(int max) throws SQLException {
            throw new NotImplementedException(".setMaxRows");
        }

        public void setQueryTimeout(int seconds) throws SQLException {
            throw new NotImplementedException(".setQueryTimeout");
        }

        public boolean getMoreResults(int current) throws SQLException {
            throw new NotImplementedException(".getMoreResults");
        }

        public void setEscapeProcessing(boolean enable) throws SQLException {
            throw new NotImplementedException(".setEscapeProcessing");
        }

        public int executeUpdate(String sql) throws SQLException {
            throw new NotImplementedException(".executeUpdate");
        }

        public void addBatch(String sql) throws SQLException {
            throw new NotImplementedException(".addBatch");
        }

        public void setCursorName(String name) throws SQLException {
            throw new NotImplementedException(".setCursorName");
        }

        public boolean execute(String sql) throws SQLException {
            throw new NotImplementedException(".execute");
        }

        public int executeUpdate(String sql, int autoGeneratedKeys) throws SQLException {
            throw new NotImplementedException(".executeUpdate");
        }

        public boolean execute(String sql, int autoGeneratedKeys) throws SQLException {
            throw new NotImplementedException(".execute");
        }

        public int executeUpdate(String sql, int columnIndexes[]) throws SQLException {
            throw new NotImplementedException(".executeUpdate");
        }

        public boolean execute(String sql, int columnIndexes[]) throws SQLException {
            throw new NotImplementedException(".execute");
        }

        public Connection getConnection() throws SQLException {
            throw new NotImplementedException(".getConnection");
        }

        public ResultSet getGeneratedKeys() throws SQLException {
            throw new NotImplementedException(".getGeneratedKeys");
        }

        public ResultSet getResultSet() throws SQLException {
            throw new NotImplementedException(".getResultSet");
        }

        public SQLWarning getWarnings() throws SQLException {
            throw new NotImplementedException(".getWarnings");
        }

        public int executeUpdate(String sql, String columnNames[]) throws SQLException {
            throw new NotImplementedException(".executeUpdate");
        }

        public boolean execute(String sql, String columnNames[]) throws SQLException {
            throw new NotImplementedException(".execute");
        }

        public ResultSet executeQuery(String sql) throws SQLException {
            throw new NotImplementedException(".executeQuery");
        }
    }
}
